#include "WinTCP.h"


WinTCP::WinTCP()
{
	 s=INVALID_SOCKET; buflen=0;
	 if (WSAStartup(MAKEWORD(1, 1),&wdata)) {
		 printf("Error: WSAStartup() failed, ERROR=%u\r\n",GetLastError());
		 exit(255);
	 }
}

WinTCP::~WinTCP()
{
	 if (s!=INVALID_SOCKET) Disconnect();
	 WSACleanup();
}

int WinTCP::Connect(unsigned char *host,unsigned port)
{
 sockaddr_in sin;
 memset(&sin,0,sizeof(sin)); buflen=0;

 sin.sin_family=AF_INET;
 sin.sin_port=htons(port);

 // Resolve host address
 hostent *hp;
 if (isdigit(host[0]))
   {
    int nd=0;
    char addr[4];
	char *p=(char *)host;
	for (int i=0; host[i]; i++) if (host[i]=='.') nd++;
	if (nd==3)
	  {
	   addr[0]=(unsigned char)atoi(p); p=strchr(p,'.')+1;
	   addr[1]=(unsigned char)atoi(p); p=strchr(p,'.')+1;
	   addr[2]=(unsigned char)atoi(p); p=strchr(p,'.')+1;
	   addr[3]=(unsigned char)atoi(p);
	   memcpy(&sin.sin_addr,&addr,4);
	  }
	else
	  {
       printf("Bad IP addres. Host '%s' not found\b\r\n",host);
	   exit(255);
	  }
   }
 else
   {
	hp=gethostbyname((const char *)host);
    if (!hp)
      {
       printf("DNS lookup failed. Host '%s' not found\b\r\n",host);
	   exit(255);
      }
    memcpy(&sin.sin_addr,hp->h_addr,hp->h_length);
   }

 // Creating socket
 if ((s=socket(AF_INET,SOCK_STREAM,0))==INVALID_SOCKET)
   {
	printf("Error: socket() failed, ERROR=%u\r\n",GetLastError());
    exit(255);
   }

 // Connect to host
 if (connect(s,(sockaddr *)&sin,sizeof(sin)))
   {
    printf("Error: connect() failed, ERROR=%u\r\n",GetLastError());
    exit(255);
   }

 return 1;
}

int WinTCP::Disconnect()
{
 if (s!=INVALID_SOCKET) {closesocket(s); s=INVALID_SOCKET;}
 buflen=0; return 1;
}


int WinTCP::Recv()
{
 buflen=0;
 DWORD starttime=0;

 starttime=GetTickCount();			// needed to calculate idle time
 int suc=recv(s,(char *)buf,1,0);	// read one byte from socket
	if (!suc) {
		 printf(CONNECTION_CLOSED);
		exit(0);
	}
	if (suc==SOCKET_ERROR) {
		printf("Error: recv() failed, ERROR=%u\r\n",GetLastError());
		exit(255);
	}
	buflen+=suc;

	 unsigned long ln=0;
	 ioctlsocket(s,FIONREAD,&ln);		// check data aviable for reading
	 if (ln) {
		 if (ln>=RECV_BUFFER) ln=RECV_BUFFER-1;
		 suc=recv(s,(char *)buf+buflen,ln,0);
		 if (!suc) {
			 printf(CONNECTION_CLOSED);
			 exit(0);
		 }
		 if (suc==SOCKET_ERROR) {
			 printf("Error: recv() failed, ERROR=%u\r\n",GetLastError());
			 exit(255);
		 }
		 buflen+=suc;
	 }
	 buf[buflen]=0;
	 ::buf.Add(buf,buflen);		// Add data to telnet buffer

 return buflen;
}

int WinTCP::Send(int b)
{
	 if (send(s,(const char *)&b,sizeof(char),0)==SOCKET_ERROR) {
		 printf("Error: send() failed, ERROR=%u\r\n",GetLastError());
		 exit(255);
 }
 return 1;
}

int WinTCP::Send(void *buf)
{
	 if (send(s,(const char *)buf,strlen((const char *)buf),0)==SOCKET_ERROR) {
		 printf("Error: send() failed, ERROR=%u\r\n",GetLastError());
		 exit(255);
 }
 return 1;
}

int WinTCP::Sendf(void *fmt,...)
{
 va_list pvar;  va_start(pvar,fmt);
 vsprintf(tmp,(char *)fmt,pvar); va_end(pvar);
 return Send(tmp);
}

int WinTCP::PrepareToSend(void *fmt,...)
{
 va_list pvar;  va_start(pvar,fmt);
 vsprintf(tmp,(char *)fmt,pvar); va_end(pvar);
 return strlen(tmp);
}

int WinTCP::PrepareCommit(int ln)
{
	 if (send(s,(const char *)tmp,ln,0)==SOCKET_ERROR) {
		 printf("Error: send() failed, ERROR=%u\r\n",GetLastError());
		 exit(255);
	 }
 return 1;
}

#define GETS_TIMEOUT	50

BOOL WinTCP::Gets(void *b)
{
	BOOL retv=FALSE;
	((char *)b)[0]=0;

retry:
	while (::buf.Len()==0) Sleep(GETS_TIMEOUT);

	for (unsigned i=0; i<::buf.Len(); i++) {
		if (::buf[i]=='\r') continue;
		if (::buf[i]=='\n') {
			retv=TRUE; 
			::buf.Del(i+1);
			break;
		}
		((char *)b)[i]=::buf[i];
		((char *)b)[i+1]=0;
	}
	if (!retv && ::buf.Len()>0) {
		Sleep(GETS_TIMEOUT); goto retry;
	}
	return retv;
}
