#include "buffer.h"
#include "wintcp.h"

#define POP3_PORT	110				// Well-know port assignment
#define POP_OK		"+OK"
#define MAXREPL		 262144
#define MAX_PAR_L	80
#define MAX_CMD_L	4096

char p_host[MAX_PAR_L+1];
char p_user[MAX_PAR_L+1];
char p_pass[MAX_PAR_L+1];
char p_cmnd[MAX_CMD_L+1];
BOOL delete_flag=FALSE;

WinTCP tcp;
Buffer buf;

BOOL GetAnswer(char *s)
{
	BOOL retv=tcp.Gets(s);
	if (retv && strstr(s,POP_OK)!=s) {
		printf("ERROR: POP3 protocol error!\n");
		exit(255);
	}
	return retv;
}

DWORD ProcessNetwork()
{
 for (;;) tcp.Recv();
 return 0;
}

int main(int argc,char *argv[])
{
	static char repl[MAXREPL+1];
	int i,n;

	if (argc<5) {
		printf("\n");
		printf("POP3GET Console POP3-client for Windows NT/95 version 1.0 August 1997\n");
		for (i=0; i<79; i++) printf("\xc4"); printf("\n");
		printf("Usage: pop3get [-del] <host> <user> <pass> <command_to_make_pipe>\n");
		printf("\n");
		printf("Notes: This utility gets messages with POP3 protocol and then\n");
		printf("       make pipe to stdin stream of specified program.\n");
		for (i=0; i<79; i++) printf("\xc4"); printf("\n");
		printf("(C) Arcady V. Pchelinsev, Saratov, Russia\n");
		printf("    e-mail: arc@pvrr.ru\n");
		printf("    URL:    http://pragma.pvrr.ru\n");
		printf("    Phone:  7 (845-2) 99-55-88\n");
		Beep(3000,50);
		exit(1);
	}

	int options=0;		//  ,   
	if (argv[1][0]=='-') {
		options=1;
		if (argv[1][1]=='d' || argv[1][1]=='D') delete_flag=1;
	}

	strncpy(p_host,argv[1+options],MAX_PAR_L); p_host[MAX_PAR_L]=0;
	strncpy(p_user,argv[2+options],MAX_PAR_L); p_user[MAX_PAR_L]=0;
	strncpy(p_pass,argv[3+options],MAX_PAR_L); p_pass[MAX_PAR_L]=0;
	strncpy(p_cmnd,argv[4+options],MAX_CMD_L); p_cmnd[MAX_CMD_L]=0;
	for (i=5+options; i<argc; i++) {
		strcat(p_cmnd," ");	strcat(p_cmnd,argv[i]);
	}

	tcp.Connect((unsigned char *)p_host,POP3_PORT);


	DWORD id;
	HANDLE htr=CreateThread(0,0,(LPTHREAD_START_ROUTINE)ProcessNetwork,
                            (LPVOID)0,THREAD_SET_INFORMATION,&id);
 	SetThreadPriority(htr,THREAD_PRIORITY_HIGHEST);

	Sleep(100);
	if (buf.Len()) tcp.Gets(repl);

	tcp.Sendf("USER %s\n",p_user);
	GetAnswer(repl); //printf("%s\n",repl);

	tcp.Sendf("PASS %s\n",p_pass);
	GetAnswer(repl); //printf("%s\n",repl);

	tcp.Sendf("STAT\n");
	GetAnswer(repl); //printf("%s\n",repl);

	int nLet=atoi(&repl[strlen(POP_OK)]);
	for (n=1; n<=nLet; n++) {
		FILE *h=_popen(p_cmnd,"w");
		if (h==NULL) {
			Beep(3000,100);
			printf("ERROR: Can't make pipe to: '%s'\n",p_cmnd);
			exit(255);
		}
		tcp.Sendf("RETR %d\n",n);
		for (; tcp.Gets(repl); ) {
			if (repl[0]=='.' && repl[1]==0) break;
			fprintf(h,"%s\n",repl);
		}
		fclose(h);
	}


	for (n=1; delete_flag && n<=nLet; n++) {
		tcp.Sendf("DELE %d\n",n);
		GetAnswer(repl); //printf("%s\n",repl);
	}

	tcp.Sendf("QUIT\n"); 
	TerminateThread(htr,0);	Sleep(100);
	tcp.Disconnect();
			
	return 0; 
}
